{****************************************************************
 ****************************************************************
 ***           This file belongs to PVIEW/PSKILL              ***
 ***        Copyright (c) 2001 by -=Assarbad [GoP]=-          ***
 ***       ____________                 ___________           ***
 ***      /\   ________\               /\   _____  \          ***
 ***     /  \  \       /    __________/  \  \    \  \         ***
 ***     \   \  \   __/___ /\   _____  \  \  \____\  \        ***
 ***      \   \  \ /\___  \  \  \    \  \  \   _______\       ***
 ***       \   \  \ /   \  \  \  \    \  \  \  \      /       ***
 ***        \   \  \_____\  \  \  \____\  \  \  \____/        ***
 ***         \   \___________\  \__________\  \__\            ***
 ***          \  /           /  /          /  /  /            ***
 ***           \/___________/ \/__________/ \/__/             ***
 ***                                                          ***
 ***  May the source be with you, stranger ... :-)            ***
 ***                                                          ***
 ***  Greets from -=Assarbad [GoP]=- ...                      ***
 ***  Special greets go 2 Nico, Casper, SA, Pizza, Navarion...***
 ***[for questions/proposals drop a mail to Assarbad@ePost.de]***
 *****************************************ASCII by Assa [GoP]****
 ****************************************************************}

{$HINTS OFF}
{$WARNINGS OFF}

{$INCLUDE perftypes.pas}

{$IFNDEF INCLUDE_COMMONTYPES}
  {$INCLUDE commontypes.pas}
{$ENDIF}

FUNCTION getprocessesNT:TProcessrecs;
CONST
    HKEY_PERFLIB='SOFTWARE\Microsoft\Windows NT\CurrentVersion\Perflib';
    REGSUBKEY_COUNTERS='Counters';
    PROCESS_COUNTER='Process';
    PROCESSID_COUNTER='ID Process';
    UNKNOWN_TASK='unknown';
    INITIAL_SIZE=51200;
    EXTEND_SIZE=25600;
VAR
    currindex:integer;
    hKeyNames:HKEY;
    LID:LANGID;
    szSubKey:STRING;
    dwSize:integer;
    rc:dword;
    buf:PBYTE;
    szProcessname, currval:pchar;
    dwProcessIdCounter,
        PIC, PC:DWord;
    pPerf:PPerfDataBlock;
    pObj:PPerfObjectType;
    pCounterDef:PPerfCounterDefinition;
    pCounter:PPerfCounterBlock;
    pInst:PPerfInstanceDefinition;
    i:integer;
LABEL
    exit;
BEGIN
    lid:=MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL);
    szSubKey:=frmt('%s\%03x', [pchar(HKEY_PERFLIB), pointer(lid)]);
    rc:=RegOpenKeyEx(HKEY_LOCAL_MACHINE,
        pchar(szSubKey),
        0,
        KEY_READ,
        hKeyNames);
    IF rc<>ERROR_SUCCESS THEN GOTO exit;
    rc:=RegQueryValueEx(hKeyNames,
        REGSUBKEY_COUNTERS,
        NIL,
        NIL,
        NIL,
        @dwSize);
    IF rc<>ERROR_SUCCESS THEN GOTO exit;
    getmem(buf, dwSize);
    RegQueryValueEx(hKeynames,
        REGSUBKEY_COUNTERS,
        NIL,
        NIL,
        buf,
        @dwSize);
    currval:=pointer(buf);
    PC:=0;
    PIC:=0;
    WHILE (lStrLen(currval)>0) DO BEGIN
        currindex:=strtoint(STRING(currval));
        inc(currval, lStrLen(currval)+1);
        IF PROCESS_COUNTER=currval THEN PC:=currindex ELSE
            IF PROCESSID_COUNTER=currval THEN PIC:=currindex;
        inc(currval, lStrLen(currval)+1);
    END;
    FreeMem(buf);
    IF ((PIC=0)OR(PC=0)) THEN GOTO exit;

    szSubKey:=frmt('%u', [pointer(PC)]);
    dwSize:=INITIAL_SIZE;
    getmem(buf, dwSize);
    IF buf=NIL THEN GOTO exit;
    zeromemory(buf, dwSize);
    WHILE TRUE DO BEGIN
        rc:=RegQueryValueEx(HKEY_PERFORMANCE_DATA,
            pchar(szSubKey),
            NIL,
            @dwSize,
            buf,
            @dwSize);
        pPerf:=PPerfDataBlock(buf);
        IF ((rc=ERROR_SUCCESS)AND
            (dwSize>0)AND
            (pPerf.Signature[0]=WCHAR('P'))AND
            (pPerf.Signature[1]=WCHAR('E'))AND
            (pPerf.Signature[2]=WCHAR('R'))AND
            (pPerf.Signature[3]=WCHAR('F'))) THEN break;
        IF rc=ERROR_MORE_DATA THEN BEGIN
            inc(dwSize, EXTEND_SIZE);
            freemem(buf);
            getmem(buf, dwSize);
            zeromemory(buf, dwSize);
        END ELSE GOTO exit;//nope ... this was not the block we need
    END;
    pObj:=PPerfObjectType(DWORD(pPerf)+pPerf.HeaderLength);
    pCounterDef:=PPerfCounterDefinition(DWORD(pObj)+pObj.HeaderLength);
    FOR i:=0 TO LongInt(pObj.NumCounters)-1 DO BEGIN
        IF pCounterDef.CounterNameTitleIndex=pic THEN BEGIN
            dwProcessIdCounter:=pCounterDef.CounterOffset;
            break;
        END;
        inc(pCounterDef);
    END;
    pInst:=PPerfInstanceDefinition(DWORD(pObj)+pObj.DefinitionLength);
    getmem(szProcessName, MAX_PATH);
    FOR i:=0 TO pObj.NumInstances-1 DO BEGIN
        setlength(result, length(result)+1);
        currval:=pchar(pInst)+pInst.NameOffset;
        rc:=WideCharToMultiByte(CP_ACP,
            0,
            pwchar(currval),
            -1,
            szProcessName,
            MAX_PATH,
            NIL,
            NIL);
        IF NOT bool(rc) THEN
            result[length(result)-1].name:=UNKNOWN_TASK ELSE
            result[length(result)-1].name:=szProcessname;

        pCounter:=PPerfCounterBlock(DWORD(pInst)+pInst.ByteLength);
        result[length(result)-1].PID:=PDWORD(DWORD(pCounter)+dwProcessIdCounter)^;
        IF (result[length(result)-1].PID=0) THEN
            IF result[length(result)-1].name<>'Idle' THEN result[length(result)-1].PID:=DWORD(-1);
        pInst:=PPerfInstanceDefinition(DWORD(pCounter)+pCounter.ByteLength);
    END;
    freemem(szProcessName);
    exit:
    RegCloseKey(hKeyNames);
    RegCloseKey(HKEY_PERFORMANCE_DATA);
END;
{$WARNINGS ON}
{$HINTS ON}
